final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']
def appName = props['appName']
def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];
def output = ""
	
File tempFile = new File("temp.py")
BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))
def cellarg = cell ? " -cell " + cell : ""

def queryNames =""
queryNames = "AdminControl.queryNames('WebSphere:type=NodeSync,*')"
queryNames = "nodes = "+queryNames+".splitlines()\n"
temp.write(queryNames, 0, queryNames.length())
System.out.print queryNames
def startapp = "for node in nodes:\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\tprint \"Synchronizing node : \" + node\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\tworked = AdminControl.invoke(node, 'sync')\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\tif worked != \"true\":\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\t\tprint \"Synchronizing node failed : \" + node\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\t\tsys.exit(1)\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\telse:\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
startapp = "\t\tprint \"Synchronization Successful\"\n\n"
temp.write(startapp,0,startapp.length())
System.out.print startapp
temp.close()

def commandArgs = [commandPath + wsadmin, "-lang", "jython"]
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}
commandArgs << "-f"
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}

def startAppProc = procBuilder.start()
startAppProc.consumeProcessErrorStream(out);
output = startAppProc.text
startAppProc.waitFor()
if(startAppProc.exitValue() != 0) {
  System.out.println "Failed to synchronize nodes!\n" + output
  System.exit(1)
}
tempFile.delete()
println output
System.exit(0);
