import java.io.*;
import java.util.*;


final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']

def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];
def appName = props['appName'];
def contentType = props['contentType'];
def operation = props['operation'];
def contents = props['contents'];
def contentsuri = props['contentsuri'];
def argString = props['argString'];


File tempFile = new File("temp.py")
BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))


def optionsString = " -contents " + contents + " -operation " + operation + 
        ((contentType.equals("file")|contentType.equals("modulefile")) ? (" -contentsuri " + contentsuri): "") + 
        (argString?(" " +argString):"");
def invoke = "AdminApp.update('" + appName + "', '" + contentType + "', '[" + optionsString + " ]')"
temp.write(invoke, 0, invoke.length())
System.out.println invoke
temp.write("\nAdminConfig.save()", 0, 19)
System.out.println "AdminConfig.save()"
temp.close()


def commandArgs = [commandPath + wsadmin, "-lang", "jython"];
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}

commandArgs << "-f";
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}

def updateAppProc = procBuilder.start()
updateAppProc.consumeProcessErrorStream(out)
def output = updateAppProc.text
updateAppProc.waitFor()
if(updateAppProc.exitValue() != 0) {
    println "Failed to update the app: " + appName + "\n" + output
    System.exit(1);
}
tempFile.delete()
println output
